/* mltmod.f -- translated by f2c (version of 23 April 1993  18:34:30).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__9 = 9;
static integer c__1 = 1;
static integer c__3 = 3;

integer mltmod_(a, s, m)
integer *a, *s, *m;
{
    /* System generated locals */
    integer ret_val;

    /* Builtin functions */
    integer s_wsle(), do_lio(), e_wsle();
    /* Subroutine */ int s_stop();

    /* Local variables */
    static integer k, p, q, a0, a1, qh, rh;

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 6, 0, 0, 0 };
    static cilist io___2 = { 0, 6, 0, 0, 0 };
    static cilist io___3 = { 0, 6, 0, 0, 0 };


/* ********************************************************************** 
*/

/*     INTEGER FUNCTION MLTMOD(A,S,M) */

/*                    Returns (A*S) MOD M */

/*     This is a transcription from Pascal to Fortran of routine */
/*     MULtMod_Decompos from the paper */

/*     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package */
/*     with Splitting Facilities." ACM Transactions on Mathematical */
/*     Software, 17:98-111 (1991) */


/*                              Arguments */


/*     A, S, M  --> */
/*                         INTEGER A,S,M */

/* ********************************************************************** 
*/
/*     .. Parameters .. */
/*     .. */
/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Executable Statements .. */

/*     H = 2**((b-2)/2) where b = 32 because we are using a 32 bit */
/*      machine. On a different machine recompute H */

    if (! (*a <= 0 || *a >= *m || *s <= 0 || *s >= *m)) {
	goto L10;
    }
    s_wsle(&io___1);
    do_lio(&c__9, &c__1, " A, M, S out of order in MLTMOD - ABORT!", 40L);
    e_wsle();
    s_wsle(&io___2);
    do_lio(&c__9, &c__1, " A = ", 5L);
    do_lio(&c__3, &c__1, (char *)&(*a), (ftnlen)sizeof(integer));
    do_lio(&c__9, &c__1, " S = ", 5L);
    do_lio(&c__3, &c__1, (char *)&(*s), (ftnlen)sizeof(integer));
    do_lio(&c__9, &c__1, " M = ", 5L);
    do_lio(&c__3, &c__1, (char *)&(*m), (ftnlen)sizeof(integer));
    e_wsle();
    s_wsle(&io___3);
    do_lio(&c__9, &c__1, " MLTMOD requires: 0 < A < M; 0 < S < M", 38L);
    e_wsle();
    s_stop(" A, M, S out of order in MLTMOD - ABORT!", 40L);
L10:
    if (! (*a < 32768)) {
	goto L20;
    }
    a0 = *a;
    p = 0;
    goto L120;
L20:
    a1 = *a / 32768;
    a0 = *a - (a1 << 15);
    qh = *m / 32768;
    rh = *m - (qh << 15);
    if (! (a1 >= 32768)) {
	goto L50;
    }
    a1 += -32768;
    k = *s / qh;
    p = (*s - k * qh << 15) - k * rh;
L30:
    if (! (p < 0)) {
	goto L40;
    }
    p += *m;
    goto L30;
L40:
    goto L60;
L50:
    p = 0;

/*     P = (A2*S*H)MOD M */

L60:
    if (! (a1 != 0)) {
	goto L90;
    }
    q = *m / a1;
    k = *s / q;
    p -= k * (*m - a1 * q);
    if (p > 0) {
	p -= *m;
    }
    p += a1 * (*s - k * q);
L70:
    if (! (p < 0)) {
	goto L80;
    }
    p += *m;
    goto L70;
L80:
L90:
    k = p / qh;

/*     P = ((A2*H + A1)*S)MOD M */

    p = (p - k * qh << 15) - k * rh;
L100:
    if (! (p < 0)) {
	goto L110;
    }
    p += *m;
    goto L100;
L110:
L120:
    if (! (a0 != 0)) {
	goto L150;
    }

/*     P = ((A2*H + A1)*H*S)MOD M */

    q = *m / a0;
    k = *s / q;
    p -= k * (*m - a0 * q);
    if (p > 0) {
	p -= *m;
    }
    p += a0 * (*s - k * q);
L130:
    if (! (p < 0)) {
	goto L140;
    }
    p += *m;
    goto L130;
L140:
L150:
    ret_val = p;

    return ret_val;
} /* mltmod_ */

